diff --git a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index 89fc87b6b..d973e777f 100644
--- a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -6,36 +6,39 @@ import java.time.Instant;
 import java.util.HashMap;
 import java.util.Map;
 
+import com.mojang.logging.LogUtils;
 import de.jcm.discordgamesdk.Core;
 import de.jcm.discordgamesdk.CreateParams;
 import de.jcm.discordgamesdk.GameSDKException;
 import de.jcm.discordgamesdk.activity.Activity;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
-import net.minecraft.client.gui.GuiIngameMenu;
+import net.minecraft.client.gui.PauseScreen;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
+import org.slf4j.Logger;
 
-public class RichPresenceHandlerThread extends Thread
-{
+public class RichPresenceHandlerThread extends Thread {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private final static long clientId = 896803609696677898L;
     private Core core;
-    private Minecraft minecraft;
+    private final Minecraft minecraft;
     private Instant startTime;
     private boolean hasRegistered = false;
-    private static Map<Dimension, String> dimensionNamesMap = new HashMap<>();
-    static
-    {
+    private static final Map<Dimension, String> dimensionNamesMap = new HashMap<>();
+
+    static {
         dimensionNamesMap.put(Dimension.overworld, "the Overworld");
         dimensionNamesMap.put(Dimension.nether, "the Nether");
         dimensionNamesMap.put(Dimension.paradise, "Paradise");
     }
-    private static Map<Biome, String> biomeNamesMap = new HashMap<>();
-    static
-    {
+
+    private static final Map<Biome, String> biomeNamesMap = new HashMap<>();
+
+    static {
         biomeNamesMap.put(Biomes.OVERWORLD_RAINFOREST, "a rainforest");
         biomeNamesMap.put(Biomes.OVERWORLD_SWAMPLAND, "the swamplands");
         biomeNamesMap.put(Biomes.OVERWORLD_SEASONAL_FOREST, "a seasonal forest");
@@ -60,9 +63,10 @@ public class RichPresenceHandlerThread extends Thread
         biomeNamesMap.put(Biomes.OVERWORLD_CAATINGA, "the caatinga");
         biomeNamesMap.put(Biomes.OVERWORLD_CAATINGA_PLAINS, "the caatinga");
     }
-    private static Map<Weather, String> weatherNamesMap = new HashMap<>();
-    static
-    {
+
+    private static final Map<Weather, String> weatherNamesMap = new HashMap<>();
+
+    static {
         // overworldClear
         weatherNamesMap.put(Weathers.OVERWORLD_RAIN, "in the rain");
         weatherNamesMap.put(Weathers.OVERWORLD_SNOW, "in the snow");
@@ -74,28 +78,22 @@ public class RichPresenceHandlerThread extends Thread
         // overworldRainBlood
     }
 
-    public RichPresenceHandlerThread(Minecraft mc)
-    {
+    public RichPresenceHandlerThread(Minecraft mc) {
         this.minecraft = mc;
     }
 
     @Override
-    public void run()
-    {
+    public void run() {
         File discordLibrary;
-        try
-        {
+        try {
             discordLibrary = DownloadNativeLibrary.downloadDiscordLibrary();
-        }
-        catch (IOException e)
-        {
-            e.printStackTrace();
+        } catch (IOException e) {
+            LOGGER.warn("Error downloading Discord SDK.", e);
             return;
         }
 
-        if(discordLibrary == null)
-        {
-            System.err.println("Error downloading Discord SDK.");
+        if (discordLibrary == null) {
+            LOGGER.warn("Error downloading Discord SDK.");
             return;
         }
         // Initialize the Core
@@ -110,7 +108,7 @@ public class RichPresenceHandlerThread extends Thread
         // Run callbacks forever
         while (true) {
             if (core != null) {
-                if (!hasRegistered){
+                if (!hasRegistered) {
                     core.activityManager().registerCommand("e");
                     hasRegistered = true;
                 }
@@ -125,24 +123,18 @@ public class RichPresenceHandlerThread extends Thread
                     updateActivity();
                 }
             } catch (InterruptedException e) {
-                e.printStackTrace();
+                LOGGER.error("Unexpected Interrupt!", e);
             }
         }
     }
 
-    private void updateActivity()
-    {
-        if (!minecraft.gameSettings.discordRichPresence.value)
-        {
-            if (core != null)
-            {
+    private void updateActivity() {
+        if (!minecraft.gameSettings.discordRichPresence.value) {
+            if (core != null) {
                 destroyCore();
             }
-        }
-        else
-        {
-            if (core == null)
-            {
+        } else {
+            if (core == null) {
                 createCore();
             }
         }
@@ -153,32 +145,23 @@ public class RichPresenceHandlerThread extends Thread
         activity.assets().setLargeImage("bta-logo");
         activity.timestamps().setStart(startTime);
 
-        if (minecraft.theWorld == null)
-        {
+        if (minecraft.theWorld == null) {
             activity.setState("In the main menu");
-        }
-        else if (minecraft.theWorld != null && minecraft.thePlayer != null)
-        {
-            if (minecraft.thePlayer instanceof MultiplayerLocalPlayer)
-            {
+        } else if (minecraft.thePlayer != null) {
+            if (minecraft.thePlayer instanceof MultiplayerLocalPlayer) {
                 activity.setDetails("Multiplayer");
                 int playerCount = ((MultiplayerLocalPlayer) minecraft.thePlayer).sendQueue.players.size();
                 activity.party().size().setCurrentSize(playerCount);
                 activity.party().size().setMaxSize(100);
-            }
-            else
-            {
-                if (minecraft.currentScreen instanceof GuiIngameMenu)
-                {
+            } else {
+                if (minecraft.currentScreen instanceof PauseScreen) {
                     activity.setDetails("Singleplayer (paused)");
-                }
-                else
-                {
+                } else {
                     activity.setDetails("Singleplayer");
                 }
             }
             Dimension activeDimension = Dimension.getDimensionList().get(minecraft.thePlayer.dimension);
-            Biome biome = minecraft.theWorld.getBlockBiome((int)minecraft.thePlayer.x, (int)minecraft.thePlayer.y, (int)minecraft.thePlayer.z);
+            Biome biome = minecraft.theWorld.getBlockBiome((int) minecraft.thePlayer.x, (int) minecraft.thePlayer.y, (int) minecraft.thePlayer.z);
             Weather weather = minecraft.theWorld.getCurrentWeather();
 
             boolean displayDimension = activeDimension != null && dimensionNamesMap.containsKey(activeDimension);
@@ -186,24 +169,18 @@ public class RichPresenceHandlerThread extends Thread
             boolean displayWeather = weather != null && weatherNamesMap.containsKey(weather);
 
             StringBuilder stateString = new StringBuilder();
-            if (displayDimension)
-            {
+            if (displayDimension) {
                 stateString.append("In ").append(dimensionNamesMap.get(activeDimension));
-            }
-            else
-            {
+            } else {
                 stateString.append("Somewhere else");
             }
-            if (displayBiome || displayWeather)
-            {
+            if (displayBiome || displayWeather) {
                 stateString.append(", ");
             }
-            if (displayBiome)
-            {
+            if (displayBiome) {
                 stateString.append("exploring ").append(biomeNamesMap.get(biome));
             }
-            if (displayWeather)
-            {
+            if (displayWeather) {
                 stateString.append(" ").append(weatherNamesMap.get(weather));
             }
 
@@ -213,22 +190,20 @@ public class RichPresenceHandlerThread extends Thread
         core.activityManager().updateActivity(activity);
     }
 
-    private void createCore()
-    {
+    private void createCore() {
         try {
             CreateParams params = new CreateParams();
             params.setClientID(clientId);
             params.setFlags(CreateParams.Flags.NO_REQUIRE_DISCORD);
             // Create the Core
             core = new Core(params);
-        } catch (GameSDKException sdkException){
+        } catch (GameSDKException sdkException) {
             // Exception normally occurs only when discord is not opened on the client
             core = null;
         }
     }
 
-    private void destroyCore()
-    {
+    private void destroyCore() {
         core.close();
         core = null;
     }
diff --git a/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java b/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
index 3c51810b2..530b597ed 100644
--- a/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
+++ b/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
@@ -14,13 +14,16 @@ import com.google.gson.JsonElement;
 import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import com.google.gson.JsonParser;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 public class ClientSkinVariantList extends SkinVariantList {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public static final int MAX_VARIANT_ID = 0xFF;
 
 	private final Minecraft mc;
@@ -50,6 +53,8 @@ public class ClientSkinVariantList extends SkinVariantList {
 				return var.getKeyFromIndex(skinIndex);
 			}
 		} catch (Exception e) {
+      LOGGER.error("Failed to load json at '{}'!", variantJsonPath, e);
+			variantProcessorMap.put(variantJsonPath, null); // Null the path after an exception happened trying to load it, prevents exception spam
 			e.printStackTrace();
 		}
 		return defaultKey;
@@ -61,7 +66,7 @@ public class ClientSkinVariantList extends SkinVariantList {
 			try {
 				jsonString = StringUtils.readInputString(stream);
 			} catch (Exception e) {
-				e.printStackTrace();
+                LOGGER.error("Failed to parse '{}' as a Json String!", variantJsonPath, e);
 				break load;
 			}
             try {
@@ -86,15 +91,15 @@ public class ClientSkinVariantList extends SkinVariantList {
 						variantProcessorMap.put(variantJsonPath, new EntityVariants(variants));
 						return;
 					} else {
-						System.out.println("Error: value 'skins' must either be a integer or an array!");
+                        LOGGER.error("Error at {}: value 'skins' must either be a integer or an array!", variantJsonPath);
 						break load;
 					}
 				}
-            } catch (JsonParseException e) { // TODO, replace with proper non-fatal error logging
-                e.printStackTrace();
+            } catch (JsonParseException e) {
+                LOGGER.error("Failed to parse Json at {}", variantJsonPath, e);
             }
         } catch (IOException e) {
-            e.printStackTrace();
+            LOGGER.error("IO Exception while trying to read '{}'!", variantJsonPath, e);
 			break load;
         }
 		variantProcessorMap.put(variantJsonPath, null);
@@ -106,6 +111,7 @@ public class ClientSkinVariantList extends SkinVariantList {
 		private final int skins;
 
 		public EntityVariants(int skins) {
+			if (skins <= 0) throw new IllegalArgumentException("Skins number attribute must be at-least 1!");
 			this.skins = skins;
 			this.variantEntries = null;
 		}
@@ -117,7 +123,6 @@ public class ClientSkinVariantList extends SkinVariantList {
 			entries.sort(Comparator.comparingDouble(o -> -o.weight));
 
 			for (VariantEntry e : entries) {
-//				System.out.println(e.weight);
 				accWeight += e.weight;
 			}
 
@@ -149,7 +154,6 @@ public class ClientSkinVariantList extends SkinVariantList {
 				counts.putIfAbsent(e.textureKey, 0);
 				counts.put(e.textureKey, counts.get(e.textureKey) + 1);
 			}
-//			System.out.println(counts);
 		}
 
 		public String getKeyFromIndex(int index) {
diff --git a/src/main/java/net/minecraft/client/entity/particle/BreakingItemParticle.java b/src/main/java/net/minecraft/client/entity/particle/BreakingItemParticle.java
index 138809446..229e5628a 100644
--- a/src/main/java/net/minecraft/client/entity/particle/BreakingItemParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/BreakingItemParticle.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.LightmapHelper;
 //            EntityFX, Item, Block, Tessellator,
 //            World
 
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Blocks;
@@ -13,8 +14,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.world.World;
 
 public class BreakingItemParticle extends Particle {
-    public BreakingItemParticle(World world, double x, double y, double z, Item item)
-    {
+    public BreakingItemParticle(World world, double x, double y, double z, Item item) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.tex = ItemModelDispatcher.getInstance().getDispatch(item).getIcon(null, item.getDefaultStack());
         this.rCol = this.gCol = this.bCol = 1.0F;
@@ -23,25 +23,25 @@ public class BreakingItemParticle extends Particle {
     }
 
     @Override
-	public int getParticleTexture() {
-        return 2;
+    public int getParticleTexture() {
+        return ParticleEngine.ITEM_TEXTURE;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
         float u2 = (float) this.tex.getSubIconU(0.25f + this.uo / 4F);
         float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
         float v2 = (float) this.tex.getSubIconV(0.25f + this.uo / 4F);
         float r = 0.1F * this.size;
-        float x = (float)(xo + (this.x - this.xo) * partialTick - BreakingItemParticle.xOff);
-        float y = (float)(yo + (this.y - this.yo) * partialTick - BreakingItemParticle.yOff);
-        float z = (float)(zo + (this.z - this.zo) * partialTick - BreakingItemParticle.zOff);
+        float x = (float) (xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float) (yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float) (zo + (this.z - this.zo) * partialTick - zOff);
         float br = 1.0f;
         if (LightmapHelper.isLightmapEnabled()) {
-        	t.setLightmapCoord(getLightmapCoord(partialTick));
+            t.setLightmapCoord(getLightmapCoord(partialTick));
         } else {
-        	br = getBrightness(partialTick);
+            br = getBrightness(partialTick);
         }
         t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
         t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
diff --git a/src/main/java/net/minecraft/client/entity/particle/BubbleParticle.java b/src/main/java/net/minecraft/client/entity/particle/BubbleParticle.java
index 450f0c4a8..6d9f5237c 100644
--- a/src/main/java/net/minecraft/client/entity/particle/BubbleParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/BubbleParticle.java
@@ -17,14 +17,14 @@ public class BubbleParticle extends Particle {
         this.tex = TextureRegistry.getTexture("minecraft:particle/bubble");
         this.setSize(0.02F, 0.02F);
         this.size = this.size * (this.random.nextFloat() * 0.6F + 0.2F);
-        this.xd = xa * 0.2D + (float)(Math.random() * 2D - 1.0D) * 0.02F;
-        this.yd = ya * 0.2D + (float)(Math.random() * 2D - 1.0D) * 0.02F;
-        this.zd = za * 0.2D + (float)(Math.random() * 2D - 1.0D) * 0.02F;
-        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+        this.xd = xa * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
+        this.yd = ya * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
+        this.zd = za * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
+        this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -36,7 +36,7 @@ public class BubbleParticle extends Particle {
         if (this.needsWater && this.world.getBlockMaterial(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z)) != Material.water) {
             remove();
         }
-        if(this.lifetime-- <= 0) {
+        if (this.lifetime-- <= 0) {
             remove();
         }
     }
diff --git a/src/main/java/net/minecraft/client/entity/particle/ExplodeParticle.java b/src/main/java/net/minecraft/client/entity/particle/ExplodeParticle.java
index 3cad7ad5d..f9fa36927 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ExplodeParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ExplodeParticle.java
@@ -6,20 +6,20 @@ import net.minecraft.core.world.World;
 public class ExplodeParticle extends Particle {
     public ExplodeParticle(World world, double x, double y, double z, double xa, double ya, double za) {
         super(world, x, y, z, xa, ya, za);
-        this.xd = xa + (float)(Math.random() * 2D - 1.0D) * 0.05F;
-        this.yd = ya + (float)(Math.random() * 2D - 1.0D) * 0.05F;
-        this.zd = za + (float)(Math.random() * 2D - 1.0D) * 0.05F;
+        this.xd = xa + (Math.random() * 2D - 1.0D) * 0.05F;
+        this.yd = ya + (Math.random() * 2D - 1.0D) * 0.05F;
+        this.zd = za + (Math.random() * 2D - 1.0D) * 0.05F;
         this.rCol = this.gCol = this.bCol = this.random.nextFloat() * 0.3F + 0.7F;
         this.size = this.random.nextFloat() * this.random.nextFloat() * 6F + 1.0F;
-        this.lifetime = (int)(16D / (this.random.nextFloat() * 0.8D + 0.2D)) + 2;
+        this.lifetime = (int) (16D / (this.random.nextFloat() * 0.8D + 0.2D)) + 2;
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
-        if(this.age++ >= this.lifetime) {
+        if (this.age++ >= this.lifetime) {
             this.remove();
         }
         int val = (7 - ((this.age * 8) / this.lifetime));
diff --git a/src/main/java/net/minecraft/client/entity/particle/FireflyParticle.java b/src/main/java/net/minecraft/client/entity/particle/FireflyParticle.java
index 5336dc744..bde2b322b 100644
--- a/src/main/java/net/minecraft/client/entity/particle/FireflyParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/FireflyParticle.java
@@ -8,21 +8,20 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 public class FireflyParticle extends Particle {
-    float oSize;
-    float sinTimer = 0;
-    boolean isReversed = false;
-    float midR = 0.0f;
-    float midG = 0.0f;
-    float midB = 0.0f;
-    final float minR = 96 / 255f;
-    final float minG = 54 / 255f;
-    final float minB = 0 / 255f;
-    float maxR = 240 / 255f;
-    float maxG = 255 / 255f;
-    float maxB = 173 / 255f;
-    float oR;
-    float oG;
-    float oB;
+    private float sinTimer = 0;
+    private boolean isReversed = false;
+    private float midR = 0.0f;
+    private float midG = 0.0f;
+    private float midB = 0.0f;
+    private final float minR = 96 / 255f;
+    private final float minG = 54 / 255f;
+    private final float minB = 0 / 255f;
+    private float maxR = 240 / 255f;
+    private float maxG = 255 / 255f;
+    private float maxB = 173 / 255f;
+    private final float oR;
+    private final float oG;
+    private final float oB;
 
     public FireflyParticle(World world, double x, double y, double z, double xa, double ya, double za, int type) {
         this(world, x, y, z, xa, ya, za, 1.0F, type);
@@ -38,7 +37,6 @@ public class FireflyParticle extends Particle {
         this.zd += za;
         this.setColor(type);
         this.size = 2.0F;
-        this.oSize = size;
         this.lifetime = (int) (24D + random.nextInt(6));
         this.lifetime *= (int) scale;
         this.noPhysics = false;
@@ -51,7 +49,7 @@ public class FireflyParticle extends Particle {
         this.oB = this.random.nextFloat() * 0.06f - 0.03f;
     }
 
-    private void setColor(int type){
+    private void setColor(int type) {
         float[] color = FireflyClusterMob.FireflyColor.fireFlyColors.get(type).getMidColor();
         this.midR = color[0];
         this.midG = color[1];
@@ -70,22 +68,19 @@ public class FireflyParticle extends Particle {
     }
 
     @Override
-    public float getBrightness(float partialTick)
-    {
+    public float getBrightness(float partialTick) {
         float internalBrightness = this.getInternalBrightness(partialTick);
         float worldBrightness = super.getBrightness(partialTick);
         return Math.max(internalBrightness, worldBrightness);
     }
 
-    public float getInternalBrightness(float partialTick)
-    {
+    public float getInternalBrightness(float partialTick) {
         float b = (float) (Math.sin(this.age * 0.25f) + 1.0f) / 2f;
         return MathHelper.clamp(b, 0f, 1f);
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2)
-    {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float ibr = getInternalBrightness(partialTick);
         if (ibr < 0.5f) {
             this.rCol = MathHelper.lerp(this.minR, this.midR, ibr * 2);
@@ -101,7 +96,7 @@ public class FireflyParticle extends Particle {
         this.gCol += this.oG;
         this.bCol += this.oB;
 
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     public void renderParticleInGui(Tessellator t, float partialTick) {
@@ -121,17 +116,17 @@ public class FireflyParticle extends Particle {
         this.bCol += this.oB;
 
         float u0 = (float) tex.getIconUMin();
-        float u2 = (float) tex.getSubIconU(1/16f);
+        float u2 = (float) tex.getSubIconU(1 / 16f);
         float v0 = (float) tex.getIconVMin();
-        float v2 = (float) tex.getSubIconV(1/16f);
+        float v2 = (float) tex.getSubIconV(1 / 16f);
         float r = 0.1F * size;
-        float x = (float)(xo + (this.x - xo) * partialTick);
-        float y = (float)(yo + (this.y - yo) * partialTick);
+        float x = (float) (xo + (this.x - xo) * partialTick);
+        float y = (float) (yo + (this.y - yo) * partialTick);
         float br = 1.0f;
         if (LightmapHelper.isLightmapEnabled()) {
-        	t.setLightmapCoord(getLightmapCoord(partialTick));
+            t.setLightmapCoord(getLightmapCoord(partialTick));
         } else {
-        	br = getBrightness(partialTick);
+            br = getBrightness(partialTick);
         }
         t.setColorOpaque_F(rCol * br, gCol * br, bCol * br);
         t.addVertexWithUV(x + r, y - r, 0, u2, v2);
@@ -139,10 +134,10 @@ public class FireflyParticle extends Particle {
         t.addVertexWithUV(x - r, y + r, 0, u0, v0);
         t.addVertexWithUV(x - r, y - r, 0, u0, v2);
     }
-    
+
     @Override
     public int getLightmapCoord(float partialTick) {
-    	return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTick), 15);
+        return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTick), 15);
     }
 
     public void tickGui() {
@@ -159,7 +154,7 @@ public class FireflyParticle extends Particle {
         this.yo = this.y;
         this.xd = (MathHelper.sin((this.sinTimer) * 0.15f)) / 60f;
         this.yd = (MathHelper.cos((this.sinTimer) * 0.15f)) / 60f;
-        if (this.isReversed){
+        if (this.isReversed) {
             this.xd = -this.xd;
             this.yd = -this.yd;
         }
@@ -182,7 +177,7 @@ public class FireflyParticle extends Particle {
         this.zo = this.z;
         this.xd = (MathHelper.sin(this.sinTimer * 0.15f)) / 60f;
         this.zd = (MathHelper.cos(this.sinTimer * 0.15f)) / 60f;
-        if (this.isReversed){
+        if (this.isReversed) {
             this.xd = -this.xd;
             this.yd = -this.yd;
             this.zd = -this.zd;
diff --git a/src/main/java/net/minecraft/client/entity/particle/FlameParticle.java b/src/main/java/net/minecraft/client/entity/particle/FlameParticle.java
index 1f7b57ff3..709eb1d42 100644
--- a/src/main/java/net/minecraft/client/entity/particle/FlameParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/FlameParticle.java
@@ -8,43 +8,43 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 public class FlameParticle extends Particle {
-    private float oSize;
+    private final float oSize;
 
     public FlameParticle(World world, double x, double y, double z, double xd, double yd, double zd, Type type) {
         super(world, x, y, z, xd, yd, zd);
         this.xd = this.xd * 0.01D + xd;
         this.yd = this.yd * 0.01D + yd;
         this.zd = this.zd * 0.01D + zd;
-        x += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
-        y += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
-        z += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
+        this.x += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
+        this.y += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
+        this.z += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
         this.oSize = this.size;
         this.rCol = this.gCol = this.bCol = 1.0F;
-        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D)) + 4;
+        this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D)) + 4;
         this.noPhysics = true;
         this.tex = type.texture;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float s = ((float) age + partialTick) / (float) lifetime;
         this.size = this.oSize * (1.0F - s * s * 0.5F);
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
-	public float getBrightness(float partialTick) {
+    public float getBrightness(float partialTick) {
         float decay = MathHelper.clamp(((float) this.age + partialTick) / (float) this.lifetime, 0.0f, 1.0f);
         return super.getBrightness(partialTick) * decay + (1.0F - decay);
     }
-    
+
     @Override
     public int getLightmapCoord(float partialTick) {
-    	return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTick), 15);
+        return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTick), 15);
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -62,14 +62,14 @@ public class FlameParticle extends Particle {
     }
 
     public enum Type {
-    	ORANGE(TextureRegistry.getTexture("minecraft:particle/fire")),
-    	SOUL(TextureRegistry.getTexture("minecraft:particle/fire_soul")),
-    	BLUE(TextureRegistry.getTexture("minecraft:particle/fire_blue"));
-    	
-    	private final IconCoordinate texture;
-    	
-    	Type(IconCoordinate tex) {
-    		this.texture = tex;
-    	}
+        ORANGE(TextureRegistry.getTexture("minecraft:particle/fire")),
+        SOUL(TextureRegistry.getTexture("minecraft:particle/fire_soul")),
+        BLUE(TextureRegistry.getTexture("minecraft:particle/fire_blue"));
+
+        private final IconCoordinate texture;
+
+        Type(IconCoordinate tex) {
+            this.texture = tex;
+        }
     }
 }
